Index: squid/lib/rfc1035.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/rfc1035.c,v
retrieving revision 1.1.1.1.4.3.2.2
retrieving revision 1.1.1.1.4.3.2.3
diff -u -r1.1.1.1.4.3.2.2 -r1.1.1.1.4.3.2.3
--- squid/lib/rfc1035.c	6 Jan 2002 13:53:29 -0000	1.1.1.1.4.3.2.2
+++ squid/lib/rfc1035.c	30 Apr 2002 17:21:47 -0000	1.1.1.1.4.3.2.3
@@ -1,32 +1,32 @@
 
 /*
- * $Id: rfc1035.c,v 1.1.1.1.4.3.2.2 2002/01/06 13:53:29 serassio Exp $
+ * $Id: rfc1035.c,v 1.1.1.1.4.3.2.3 2002/04/30 17:21:47 serassio Exp $
  *
  * Low level DNS protocol routines
  * AUTHOR: Duane Wessels
  *
- * SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
+ * SQUID Web Proxy Cache          http://www.squid-cache.org/
  * ----------------------------------------------------------
  *
- *  Squid is the result of efforts by numerous individuals from the
- *  Internet community.  Development is led by Duane Wessels of the
- *  National Laboratory for Applied Network Research and funded by the
- *  National Science Foundation.  Squid is Copyrighted (C) 1998 by
- *  the Regents of the University of California.  Please see the
- *  COPYRIGHT file for full details.  Squid incorporates software
- *  developed and/or copyrighted by other sources.  Please see the
- *  CREDITS file for full details.
+ *  Squid is the result of efforts by numerous individuals from
+ *  the Internet community; see the CONTRIBUTORS file for full
+ *  details.   Many organizations have provided support for Squid's
+ *  development; see the SPONSORS file for full details.  Squid is
+ *  Copyrighted (C) 2001 by the Regents of the University of
+ *  California; see the COPYRIGHT file for full details.  Squid
+ *  incorporates software developed and/or copyrighted by other
+ *  sources; see the CREDITS file for full details.
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
- *
+ *  
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
- *
+ *  
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
@@ -73,6 +73,14 @@
 #include "snprintf.h"
 
 #define RFC1035_MAXLABELSZ 63
+#define rfc1035_unpack_error 15
+
+#if 0
+#define RFC1035_UNPACK_DEBUG  fprintf(stderr, "unpack error at %s:%d\n", __FILE__,__LINE__)
+#else
+#define RFC1035_UNPACK_DEBUG  (void)0
+#endif
+
 
 typedef struct _rfc1035_header rfc1035_header;
 
@@ -93,6 +101,12 @@
     unsigned short arcount;
 };
 
+static const char *Alphanum =
+"abcdefghijklmnopqrstuvwxyz"
+"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
+"0123456789";
+
+
 /*
  * rfc1035HeaderPack()
  * 
@@ -169,12 +183,15 @@
  * Note message compression is not supported here.
  * Returns number of octets packed.
  */
-off_t
+static off_t
 rfc1035NamePack(char *buf, size_t sz, const char *name)
 {
     off_t off = 0;
     char *copy = strdup(name);
     char *t;
+    /*
+     * NOTE: use of strtok here makes names like foo....com valid.
+     */
     for (t = strtok(copy, "."); t; t = strtok(NULL, "."))
 	off += rfc1035LabelPack(buf + off, sz - off, t);
     free(copy);
@@ -214,21 +231,29 @@
  * 
  * Unpacks a RFC1035 message header buffer into a rfc1035_header
  * structure.
- * Returns the new buffer offset, which is the same as number of
+ *
+ * Updates the buffer offset, which is the same as number of
  * octects unpacked since the header starts at offset 0.
+ *
+ * Returns 0 (success) or 1 (error)
  */
-static off_t
-rfc1035HeaderUnpack(const char *buf, size_t sz, rfc1035_header * h)
+static int
+rfc1035HeaderUnpack(const char *buf, size_t sz, off_t * off, rfc1035_header * h)
 {
     unsigned short s;
     unsigned short t;
-    off_t off = 0;
-    assert(sz >= 12);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    assert(*off == 0);
+    /*
+     * The header is 12 octets.  This is a bogus message if the size
+     * is less than that.
+     */
+    if (sz < 12)
+	return 1;
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     h->id = ntohs(s);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     t = ntohs(s);
     h->qr = (t >> 15) & 0x01;
     h->opcode = (t >> 11) & 0x0F;
@@ -236,21 +261,26 @@
     h->tc = (t >> 9) & 0x01;
     h->rd = (t >> 8) & 0x01;
     h->ra = (t >> 7) & 0x01;
+    /*
+     * We might want to check that the reserved 'Z' bits (6-4) are
+     * all zero as per RFC 1035.  If not the message should be
+     * rejected.
+     */
     h->rcode = t & 0x0F;
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     h->qdcount = ntohs(s);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     h->ancount = ntohs(s);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     h->nscount = ntohs(s);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     h->arcount = ntohs(s);
-    assert(off == 12);
-    return off;
+    assert((*off) == 12);
+    return 0;
 }
 
 /*
@@ -264,43 +294,61 @@
  *
  * Supports the RFC1035 message compression through recursion.
  *
- * Returns the new buffer offset.
+ * Updates the new buffer offset.
+ *
+ * Returns 0 (success) or 1 (error)
  */
-static off_t
-rfc1035NameUnpack(const char *buf, size_t sz, off_t off, char *name, size_t ns)
+static int
+rfc1035NameUnpack(const char *buf, size_t sz, off_t * off, char *name, size_t ns, int rdepth)
 {
     off_t no = 0;
     unsigned char c;
     size_t len;
     assert(ns > 0);
     do {
-	c = *(buf + off);
-	if (c > RFC1035_MAXLABELSZ) {
-	    /* fucking compression */
+	assert((*off) < sz);
+	c = *(buf + (*off));
+	if (c > 191) {
+	    /* blasted compression */
 	    unsigned short s;
 	    off_t ptr;
-	    memcpy(&s, buf + off, sizeof(s));
+	    if (rdepth > 64)		/* infinite pointer loop */
+		return 1;
+	    memcpy(&s, buf + (*off), sizeof(s));
 	    s = ntohs(s);
-	    off += sizeof(s);
+	    (*off) += sizeof(s);
+	    /* Sanity check */
+	    if ((*off) >= sz)
+		return 1;
 	    ptr = s & 0x3FFF;
-	    (void) rfc1035NameUnpack(buf, sz, ptr, name + no, ns - no);
-	    return off;
+	    /* Make sure the pointer is inside this message */
+	    if (ptr >= sz)
+		return 1;
+	    return rfc1035NameUnpack(buf, sz, &ptr, name + no, ns - no, rdepth + 1);
+	} else if (c > RFC1035_MAXLABELSZ) {
+	    /*
+	     * "(The 10 and 01 combinations are reserved for future use.)"
+	     */
+	    return 1;
 	} else {
-	    off++;
+	    (*off)++;
 	    len = (size_t) c;
 	    if (len == 0)
 		break;
-	    if (len > (ns - 1))
-		len = ns - 1;
-	    memcpy(name + no, buf + off, len);
-	    off += len;
+	    if (len > (ns - no - 1))	/* label won't fit */
+		return 1;
+	    if ((*off) + len > sz)	/* message is too short */
+		return 1;
+	    memcpy(name + no, buf + (*off), len);
+	    (*off) += len;
 	    no += len;
 	    *(name + (no++)) = '.';
 	}
-    } while (c > 0);
+    } while (c > 0 && no < ns);
     *(name + no - 1) = '\0';
+    /* make sure we didn't allow someone to overflow the name buffer */
     assert(no <= ns);
-    return off;
+    return 0;
 }
 
 /*
@@ -308,49 +356,78 @@
  * 
  * Unpacks a RFC1035 Resource Record into 'RR' from a message buffer.
  * The caller must free RR->rdata!
- * Returns the new message buffer offset.
+ *
+ * Updates the new message buffer offset.
+ *
+ * Returns 0 (success) or 1 (error)
  */
-static off_t
-rfc1035RRUnpack(const char *buf, size_t sz, off_t off, rfc1035_rr * RR)
+static int
+rfc1035RRUnpack(const char *buf, size_t sz, off_t * off, rfc1035_rr * RR)
 {
     unsigned short s;
     unsigned int i;
-    off = rfc1035NameUnpack(buf, sz, off, RR->name, RFC1035_MAXHOSTNAMESZ);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    off_t rdata_off;
+    if (rfc1035NameUnpack(buf, sz, off, RR->name, RFC1035_MAXHOSTNAMESZ, 0)) {
+	RFC1035_UNPACK_DEBUG;
+	memset(RR, '\0', sizeof(*RR));
+	return 1;
+    }
+    /*
+     * Make sure the remaining message has enough octets for the
+     * rest of the RR fields.
+     */
+    if ((*off) + 10 > sz) {
+	RFC1035_UNPACK_DEBUG;
+	memset(RR, '\0', sizeof(*RR));
+	return 1;
+    }
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     RR->type = ntohs(s);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
     RR->class = ntohs(s);
-    memcpy(&i, buf + off, sizeof(i));
-    off += sizeof(i);
+    memcpy(&i, buf + (*off), sizeof(i));
+    (*off) += sizeof(i);
     RR->ttl = ntohl(i);
-    memcpy(&s, buf + off, sizeof(s));
-    off += sizeof(s);
-    if (off + ntohs(s) > sz) {
+    memcpy(&s, buf + (*off), sizeof(s));
+    (*off) += sizeof(s);
+    if ((*off) + ntohs(s) > sz) {
 	/*
 	 * We got a truncated packet.  'dnscache' truncates UDP
-	 * replies at 512 octets, as per RFC 1035.  Returning sz+1
-	 * should cause no further processing for this reply.
+	 * replies at 512 octets, as per RFC 1035.
 	 */
-	return sz + 1;
+	RFC1035_UNPACK_DEBUG;
+	memset(RR, '\0', sizeof(*RR));
+	return 1;
     }
+    RR->rdlength = ntohs(s);
     switch (RR->type) {
     case RFC1035_TYPE_PTR:
 	RR->rdata = malloc(RFC1035_MAXHOSTNAMESZ);
-	rfc1035NameUnpack(buf, sz, off, RR->rdata, RFC1035_MAXHOSTNAMESZ);
-	RR->rdlength = strlen(RR->rdata);
+	rdata_off = *off;
+	if (rfc1035NameUnpack(buf, sz, &rdata_off, RR->rdata, RFC1035_MAXHOSTNAMESZ, 0))
+	    return 1;
+	if (rdata_off != ((*off) + RR->rdlength)) {
+	    /*
+	     * This probably doesn't happen for valid packets, but
+	     * I want to make sure that NameUnpack doesn't go beyond
+	     * the RDATA area.
+	     */
+	    RFC1035_UNPACK_DEBUG;
+	    memset(RR, '\0', sizeof(*RR));
+	    return 1;
+	}
 	break;
     case RFC1035_TYPE_A:
     default:
-	RR->rdlength = ntohs(s);
 	RR->rdata = malloc(RR->rdlength);
-	memcpy(RR->rdata, buf + off, RR->rdlength);
+	memcpy(RR->rdata, buf + (*off), RR->rdlength);
 	break;
     }
-    off += ntohs(s);
-    assert(off <= sz);
-    return off;
+    (*off) += RR->rdlength;
+    assert((*off) <= sz);
+    return 0;
 }
 
 static unsigned short
@@ -362,6 +439,43 @@
     return qid;
 }
 
+static void
+rfc1035SetErrno(int n)
+{
+    switch (rfc1035_errno = n) {
+    case 0:
+	rfc1035_error_message = "No error condition";
+	break;
+    case 1:
+	rfc1035_error_message = "Format Error: The name server was "
+	    "unable to interpret the query.";
+	break;
+    case 2:
+	rfc1035_error_message = "Server Failure: The name server was "
+	    "unable to process this query.";
+	break;
+    case 3:
+	rfc1035_error_message = "Name Error: The domain name does "
+	    "not exist.";
+	break;
+    case 4:
+	rfc1035_error_message = "Not Implemented: The name server does "
+	    "not support the requested kind of query.";
+	break;
+    case 5:
+	rfc1035_error_message = "Refused: The name server refuses to "
+	    "perform the specified operation.";
+	break;
+    case rfc1035_unpack_error:
+	rfc1035_error_message = "The DNS reply message is corrupt or could "
+	    "not be safely parsed.";
+	break;
+    default:
+	rfc1035_error_message = "Unknown Error";
+	break;
+    }
+}
+
 void
 rfc1035RRDestroy(rfc1035_rr * rr, int n)
 {
@@ -375,6 +489,17 @@
     free(rr);
 }
 
+/*
+ * rfc1035AnswersUnpack()
+ *
+ * Takes the contents of a DNS reply and fills in an array
+ * of resource record structures.  The records array is allocated
+ * here, and should be freed by calling rfc1035RRDestroy().
+ *
+ * Returns number of records unpacked, zero if DNS reply indicates
+ * zero answers, or an error number < 0.
+ */
+
 int
 rfc1035AnswersUnpack(const char *buf,
     size_t sz,
@@ -388,40 +513,17 @@
     rfc1035_header hdr;
     rfc1035_rr *recs;
     memset(&hdr, '\0', sizeof(hdr));
-    off = rfc1035HeaderUnpack(buf + off, sz - off, &hdr);
+    if (rfc1035HeaderUnpack(buf + off, sz - off, &off, &hdr)) {
+	RFC1035_UNPACK_DEBUG;
+	rfc1035SetErrno(rfc1035_unpack_error);
+	return -rfc1035_unpack_error;
+    }
     *id = hdr.id;
     rfc1035_errno = 0;
     rfc1035_error_message = NULL;
     if (hdr.rcode) {
-	rfc1035_errno = (int) hdr.rcode;
-	switch (rfc1035_errno) {
-	case 0:
-	    rfc1035_error_message = "No error condition";
-	    break;
-	case 1:
-	    rfc1035_error_message = "Format Error: The name server was "
-		"unable to interpret the query.";
-	    break;
-	case 2:
-	    rfc1035_error_message = "Server Failure: The name server was "
-		"unable to process this query.";
-	    break;
-	case 3:
-	    rfc1035_error_message = "Name Error: The domain name does "
-		"not exist.";
-	    break;
-	case 4:
-	    rfc1035_error_message = "Not Implemented: The name server does "
-		"not support the requested kind of query.";
-	    break;
-	case 5:
-	    rfc1035_error_message = "Refused: The name server refuses to "
-		"perform the specified operation.";
-	    break;
-	default:
-	    rfc1035_error_message = "Unknown Error";
-	    break;
-	}
+	RFC1035_UNPACK_DEBUG;
+	rfc1035SetErrno((int) hdr.rcode);
 	return -rfc1035_errno;
     }
     i = (int) hdr.qdcount;
@@ -430,30 +532,50 @@
 	do {
 	    l = (int) (unsigned char) *(buf + off);
 	    off++;
-	    if (l > RFC1035_MAXLABELSZ) {	/* compression */
+	    if (l > 191) {	/* compression */
 		off++;
 		break;
+	    } else if (l > RFC1035_MAXLABELSZ) {
+		/* illegal combination of compression bits */
+		RFC1035_UNPACK_DEBUG;
+		rfc1035SetErrno(rfc1035_unpack_error);
+		return -rfc1035_unpack_error;
 	    } else {
 		off += l;
 	    }
 	} while (l > 0);	/* a zero-length label terminates */
 	off += 4;		/* qtype, qclass */
-	assert(off <= sz);
+	if (off > sz) {
+	    RFC1035_UNPACK_DEBUG;
+	    rfc1035SetErrno(rfc1035_unpack_error);
+	    return -rfc1035_unpack_error;
+	}
     }
     i = (int) hdr.ancount;
     if (i == 0)
 	return 0;
     recs = calloc(i, sizeof(*recs));
     while (i--) {
-	off = rfc1035RRUnpack(buf, sz, off, &recs[i]);
-	if (off > sz)		/* truncated packet */
+	if (off >= sz) {	/* corrupt packet */
+	    RFC1035_UNPACK_DEBUG;
 	    break;
+	}
+	if (rfc1035RRUnpack(buf, sz, &off, &recs[i])) {		/* corrupt RR */
+	    RFC1035_UNPACK_DEBUG;
+	    break;
+	}
 	nr++;
     }
-    if (nr > 0)
-	*records = recs;
-    else
+    if (nr == 0) {
+	/*
+	 * we expected to unpack some answers (ancount != 0), but
+	 * didn't actually get any.
+	 */
 	free(recs);
+	rfc1035SetErrno(rfc1035_unpack_error);
+	return -rfc1035_unpack_error;
+    }
+    *records = recs;
     return nr;
 }
 
@@ -471,9 +593,14 @@
 rfc1035BuildAQuery(const char *hostname, char *buf, size_t * szp)
 {
     static rfc1035_header h;
-    off_t offset = 0;
+    size_t offset = 0;
     size_t sz = *szp;
     memset(&h, '\0', sizeof(h));
+    /* the first char of hostname must be alphanmeric */
+    if (NULL == strchr(Alphanum, *hostname)) {
+	rfc1035SetErrno(3);
+	return 0;
+    }
     h.id = rfc1035Qid();
     h.qr = 0;
     h.rd = 1;
@@ -504,7 +631,7 @@
 rfc1035BuildPTRQuery(const struct in_addr addr, char *buf, size_t * szp)
 {
     static rfc1035_header h;
-    off_t offset = 0;
+    size_t offset = 0;
     size_t sz = *szp;
     static char rev[32];
     unsigned int i;
@@ -527,7 +654,7 @@
 	RFC1035_TYPE_PTR,
 	RFC1035_CLASS_IN);
     assert(offset <= sz);
-    *szp = (size_t) offset;
+    *szp = offset;
     return h.id;
 }
 
@@ -559,6 +686,10 @@
     int s;
     int rl;
     struct sockaddr_in S;
+    if (3 != argc) {
+	fprintf(stderr, "usage: %s ip port\n", argv[0]);
+	return 1;
+    }
     setbuf(stdout, NULL);
     setbuf(stderr, NULL);
     s = socket(PF_INET, SOCK_DGRAM, 0);
@@ -566,6 +697,10 @@
 	perror("socket");
 	return 1;
     }
+    memset(&S, '\0', sizeof(S));
+    S.sin_family = AF_INET;
+    S.sin_port = htons(atoi(argv[2]));
+    S.sin_addr.s_addr = inet_addr(argv[1]);
     while (fgets(input, 512, stdin)) {
 	struct in_addr junk;
 	strtok(input, "\r\n");
@@ -576,10 +711,6 @@
 	} else {
 	    sid = rfc1035BuildAQuery(input, buf, &sz);
 	}
-	memset(&S, '\0', sizeof(S));
-	S.sin_family = AF_INET;
-	S.sin_port = htons(53);
-	S.sin_addr.s_addr = inet_addr("128.117.28.219");
 	sendto(s, buf, sz, 0, (struct sockaddr *) &S, sizeof(S));
 	do {
 	    fd_set R;
@@ -597,7 +728,7 @@
 	memset(rbuf, '\0', 512);
 	rl = recv(s, rbuf, 512, 0);
 	{
-	    unsigned short rid;
+	    unsigned short rid = 0;
 	    int i;
 	    int n;
 	    rfc1035_rr *answers = NULL;
@@ -605,10 +736,10 @@
 		rl,
 		&answers,
 		&rid);
-	    if (rid != sid) {
-		printf("ERROR, ID mismatch (%#hx, %#hx)\n", sid, rid);
-	    } else if (n < 0) {
+	    if (n < 0) {
 		printf("ERROR %d\n", rfc1035_errno);
+	    } else if (rid != sid) {
+		printf("ERROR, ID mismatch (%#hx, %#hx)\n", sid, rid);
 	    } else {
 		printf("%d answers\n", n);
 		for (i = 0; i < n; i++) {
Index: squid/lib/util.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/util.c,v
retrieving revision 1.1.1.3.4.2.2.3
retrieving revision 1.1.1.3.4.2.2.4
diff -u -r1.1.1.3.4.2.2.3 -r1.1.1.3.4.2.2.4
--- squid/lib/util.c	27 Jan 2002 19:37:44 -0000	1.1.1.3.4.2.2.3
+++ squid/lib/util.c	30 Apr 2002 17:21:47 -0000	1.1.1.3.4.2.2.4
@@ -1,6 +1,6 @@
 
 /*
- * $Id: util.c,v 1.1.1.3.4.2.2.3 2002/01/27 19:37:44 serassio Exp $
+ * $Id: util.c,v 1.1.1.3.4.2.2.4 2002/04/30 17:21:47 serassio Exp $
  *
  * DEBUG: 
  * AUTHOR: Harvest Derived
@@ -607,7 +607,11 @@
 {
     static char xstrerror_buf[BUFSIZ];
     if (errno < 0 || errno >= sys_nerr)
+#ifdef _SQUID_MSWIN_
+	strncpy(xstrerror_buf, wsastrerror(errno), BUFSIZ);
+#else
 	snprintf(xstrerror_buf, BUFSIZ, "(%d) Unknown", errno);
+#endif
     else
 	snprintf(xstrerror_buf, BUFSIZ, "(%d) %s", errno, strerror(errno));
     return xstrerror_buf;
@@ -622,7 +626,11 @@
 {
     static char xbstrerror_buf[BUFSIZ];
     if (err < 0 || err >= sys_nerr)
+#ifdef _SQUID_MSWIN_
+	strncpy(xbstrerror_buf, wsastrerror(err), BUFSIZ);
+#else
 	snprintf(xbstrerror_buf, BUFSIZ, "(%d) Unknown", err);
+#endif
     else
 	snprintf(xbstrerror_buf, BUFSIZ, "(%d) %s", err, strerror(err));
     return xbstrerror_buf;
Index: squid/lib/win32lib.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/win32lib.c,v
retrieving revision 1.1.2.9
retrieving revision 1.1.2.10
diff -u -r1.1.2.9 -r1.1.2.10
--- squid/lib/win32lib.c	3 Feb 2002 15:16:28 -0000	1.1.2.9
+++ squid/lib/win32lib.c	30 Apr 2002 17:21:47 -0000	1.1.2.10
@@ -1,5 +1,5 @@
 /*
- * $Id: win32lib.c,v 1.1.2.9 2002/02/03 15:16:28 serassio Exp $
+ * $Id: win32lib.c,v 1.1.2.10 2002/04/30 17:21:47 serassio Exp $
  *
  * * * * * * * * Legal stuff * * * * * * *
  *
@@ -37,6 +37,10 @@
 #define OPTERRNF (2)
 #define OPTERRARG (3)
 
+__declspec(thread) int ws32_result;
+__declspec(thread) int _so_err;
+__declspec(thread) int _so_err_siz;
+
 char *optarg;
 int optreset = 0;
 int optind = 1;
@@ -45,35 +49,35 @@
 
 int chroot (const char *dirname)
 {
-    if (SetCurrentDirectory(dirname))
-	return 0;
-    else
-	return GetLastError();
+	if (SetCurrentDirectory(dirname))
+		return 0;
+	else
+		return GetLastError();
 }
 
 int kill(pid_t pid, int sig)
 {
-    HANDLE hProcess;
+   	HANDLE hProcess;
 
-    if (sig == 0) {
-	if ((hProcess = OpenProcess(PROCESS_QUERY_INFORMATION |
-	    PROCESS_VM_READ,
-	    FALSE, pid)) == NULL)
-	    return -1;
-	else {
-	    CloseHandle(hProcess);
-	    return 0;
+	if (sig == 0) {
+		if ((hProcess = OpenProcess(PROCESS_QUERY_INFORMATION |
+		    PROCESS_VM_READ,
+		    FALSE, pid)) == NULL)
+				return -1;
+		else {
+        	CloseHandle(hProcess);
+			return 0;
+		}
 	}
-    }
-    else return 0;
+	else return 0;
 }
 
 int gettimeofday( struct timeval * pcur_time,void * tz){
-    struct _timeb current;
-    _ftime(&current);
-    pcur_time->tv_sec=current.time;
-    pcur_time->tv_usec=current.millitm * 1000;
-    return 0;
+	struct _timeb current;
+	_ftime(&current);
+	pcur_time->tv_sec=current.time;
+	pcur_time->tv_usec=current.millitm * 1000;
+	return 0;
 }
 
 int statfs(const char *path, struct statfs *sfs)
@@ -84,22 +88,22 @@
 
     if (!sfs)
     {
-	errno=EINVAL;
-	return -1;
+		errno=EINVAL;
+		return -1;
     }
 
     strncpy(drive,path,2);
-    drive[2]='\0';
-    strcat(drive,"\\");
+	drive[2]='\0';
+	strcat(drive,"\\");
 
     if (!GetDiskFreeSpace(drive, &spc, &bps, &freec, &totalc)) {
-	errno = ENOENT;
-	return -1;
+      errno=ENOENT;
+      return -1;
     }
     if (!GetVolumeInformation(drive, NULL, 0, &vsn, &maxlen, &flags, NULL, 0))
     {
-	errno = ENOENT;
-	return -1;
+      errno=ENOENT;
+      return -1;
     }
     sfs->f_type = flags;
     sfs->f_bsize = spc*bps;
@@ -138,6 +142,7 @@
     optopt = argv[oint][optchr];
     return('?');
 }
+    
 
 int
 getopt(int argc, char* const *argv, const char *optstr)
@@ -149,11 +154,11 @@
 
     if (optreset)
         optreset = optchr = dash = 0;
-    if(optind >= argc)
+    if (optind >= argc)
         return(EOF);
-    if(!dash && (argv[optind][0] !=  '-'))
+    if (!dash && (argv[optind][0] !=  '-'))
         return(EOF);
-    if(!dash && (argv[optind][0] ==  '-') && !argv[optind][1])
+    if (!dash && (argv[optind][0] == '-') && !argv[optind][1])
     {
         /*
          * use to specify stdin. Need to let pgm process this and
@@ -161,13 +166,13 @@
          */
         return(EOF);
     }
-    if((argv[optind][0] == '-') && (argv[optind][1] == '-'))
+    if ((argv[optind][0] == '-') && (argv[optind][1] == '-'))
     {
         /* -- indicates end of args */
         optind++;
         return(EOF);
     }
-    if(!dash)
+    if (!dash)
     {
         assert((argv[optind][0] == '-') && argv[optind][1]);
         dash = 1;
@@ -283,21 +288,22 @@
 	break;
     }
     if (errind == -1)
-	return ("Unknown");
-    assert(err == _wsaerrtext[errind].err);
-    snprintf(xwsaerror_buf, BUFSIZ, "(%d) %s, %s", err, _wsaerrtext[errind].errconst, _wsaerrtext[errind].errdesc);
+	snprintf(xwsaerror_buf, BUFSIZ, "(%d) Unknown", err);
+    else
+	snprintf(xwsaerror_buf, BUFSIZ, "(%d) %s, %s", err, _wsaerrtext[errind].errconst, _wsaerrtext[errind].errdesc);
     return xwsaerror_buf;
 }
 
 struct passwd *getpwnam(char * unused)
 {
-    static struct passwd pwd = {100};
-    return &pwd;
+	static struct passwd pwd = {100};
+	return &pwd;
 }
 
 struct group *getgrnam(char * unused)
 {
-    static struct group grp = {100};
-    return &grp;
+	static struct group grp = {100};
+	return &grp;
 }
+
 #endif
Index: squid/snmplib/snmp_vars.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/snmplib/snmp_vars.c,v
retrieving revision 1.1.1.2.56.1
retrieving revision 1.1.1.2.56.2
diff -u -r1.1.1.2.56.1 -r1.1.1.2.56.2
--- squid/snmplib/snmp_vars.c	16 Feb 2002 18:20:32 -0000	1.1.1.2.56.1
+++ squid/snmplib/snmp_vars.c	30 Apr 2002 17:21:47 -0000	1.1.1.2.56.2
@@ -402,9 +402,6 @@
     printf("VARS: All Variable length %d\n", AllVarLen);
 #endif
 
-#if defined PARSE_ERROR
-#undef PARSE_ERROR
-#endif
 #define PARSE_ERROR { snmp_var_free(Var); return(NULL); }
 
     /* We know how long the variable list is.  Parse it. */
Index: squid/src/acl.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/acl.c,v
retrieving revision 1.1.1.3.4.3.2.6
retrieving revision 1.1.1.3.4.3.2.7
diff -u -r1.1.1.3.4.3.2.6 -r1.1.1.3.4.3.2.7
--- squid/src/acl.c	29 Sep 2001 07:58:59 -0000	1.1.1.3.4.3.2.6
+++ squid/src/acl.c	30 Apr 2002 17:21:48 -0000	1.1.1.3.4.3.2.7
@@ -1,6 +1,6 @@
 
 /*
- * $Id: acl.c,v 1.1.1.3.4.3.2.6 2001/09/29 07:58:59 serassio Exp $
+ * $Id: acl.c,v 1.1.1.3.4.3.2.7 2002/04/30 17:21:48 serassio Exp $
  *
  * DEBUG: section 28    Access Control
  * AUTHOR: Duane Wessels
@@ -110,7 +110,9 @@
   strtok_again:
     if (!aclFromFile) {
 	t = (strtok(NULL, w_space));
-	if (t && (*t == '\"' || *t == '\'')) {
+	if (!t || *t == '#') {
+	    return NULL;
+	} else if (*t == '\"' || *t == '\'') {
 	    /* quote found, start reading from file */
 	    fn = ++t;
 	    while (*t && *t != '\"' && *t != '\'')
Index: squid/src/cache_manager.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cache_manager.c,v
retrieving revision 1.1.1.2.4.1.2.4
retrieving revision 1.1.1.2.4.1.2.5
diff -u -r1.1.1.2.4.1.2.4 -r1.1.1.2.4.1.2.5
--- squid/src/cache_manager.c	6 Apr 2002 17:37:34 -0000	1.1.1.2.4.1.2.4
+++ squid/src/cache_manager.c	30 Apr 2002 17:21:48 -0000	1.1.1.2.4.1.2.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: cache_manager.c,v 1.1.1.2.4.1.2.4 2002/04/06 17:37:34 serassio Exp $
+ * $Id: cache_manager.c,v 1.1.1.2.4.1.2.5 2002/04/30 17:21:48 serassio Exp $
  *
  * DEBUG: section 16    Cache Manager Objects
  * AUTHOR: Duane Wessels
@@ -306,21 +306,11 @@
 static void
 cachemgrOfflineToggle(StoreEntry * sentry)
 {
-    switch(Config.offline)
-    {
-	case 0:
-	    Config.offline=2;
-	    break;
-	case 1:
-	    break;
-	case 2:
-	    Config.offline=0;
-	    break;
-    }
+    Config.onoff.offline = !Config.onoff.offline;
     debug(16, 0) ("offline_mode now %s.\n",
-	Config.offline ? (Config.offline==1?"MAYBE":"ON") : "OFF");
+	Config.onoff.offline ? "ON" : "OFF");
     storeAppendPrintf(sentry, "offline_mode is now %s\n",
-	Config.offline ? (Config.offline==1?"MAYBE":"ON") : "OFF");
+	Config.onoff.offline ? "ON" : "OFF");
 }
 static const char *
 cachemgrActionProtection(const action_table * at)
Index: squid/src/cf.data.pre
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/cf.data.pre,v
retrieving revision 1.1.1.3.4.3.2.4
retrieving revision 1.1.1.3.4.3.2.5
diff -u -r1.1.1.3.4.3.2.4 -r1.1.1.3.4.3.2.5
--- squid/src/cf.data.pre	10 Feb 2002 17:55:55 -0000	1.1.1.3.4.3.2.4
+++ squid/src/cf.data.pre	30 Apr 2002 17:21:48 -0000	1.1.1.3.4.3.2.5
@@ -1,6 +1,6 @@
 
 #
-# $Id: cf.data.pre,v 1.1.1.3.4.3.2.4 2002/02/10 17:55:55 serassio Exp $
+# $Id: cf.data.pre,v 1.1.1.3.4.3.2.5 2002/04/30 17:21:48 serassio Exp $
 #
 #
 # SQUID Internet Object Cache  http://squid.nlanr.net/Squid/
@@ -2995,25 +2995,12 @@
 DOC_NONE
 
 NAME: offline_mode
-TYPE: int
-LOC: Config.offline
-DEFAULT: 0
-DOC_START
-	If set to 2, Squid will never try to validate cached objects.
-	If set to 1, Squid will not try to cache objects if network_interface
-	is down
-	If set to 0, Squid will operate normally.
-DOC_END
-
-NAME: network_interface
-TYPE: eol
-LOC: Config.network_interface
-DEFAULT: none
+TYPE: onoff
+LOC: Config.onoff.offline
+DEFAULT: off
 DOC_START
-	Used in conjunction with the new offline code. If offline_mode is 1,
-	then the status of this interface (up or down) tells us if
-	we should be operating in offline mode. If it's down, we pretend
-	we're in offline mode. If it's up, we behave normally.
+	Enable this option and Squid will never try to validate cached
+	objects.
 DOC_END
 
 NAME: uri_whitespace
Index: squid/src/client_side.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/client_side.c,v
retrieving revision 1.1.1.3.4.6.2.8
retrieving revision 1.1.1.3.4.6.2.9
diff -u -r1.1.1.3.4.6.2.8 -r1.1.1.3.4.6.2.9
--- squid/src/client_side.c	10 Feb 2002 17:55:55 -0000	1.1.1.3.4.6.2.8
+++ squid/src/client_side.c	30 Apr 2002 17:21:48 -0000	1.1.1.3.4.6.2.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: client_side.c,v 1.1.1.3.4.6.2.8 2002/02/10 17:55:55 serassio Exp $
+ * $Id: client_side.c,v 1.1.1.3.4.6.2.9 2002/04/30 17:21:48 serassio Exp $
  *
  * DEBUG: section 33    Client-side Routines
  * AUTHOR: Duane Wessels
@@ -112,10 +112,6 @@
 static int clientReplyBodyTooLarge(int clen);
 static int clientRequestBodyTooLarge(int clen);
 
-#ifdef _SQUID_MSWIN_
-#define xstrerror() wsastrerror(errno)
-#endif
-
 static int
 checkAccelOnly(clientHttpRequest * http)
 {
@@ -1432,7 +1428,7 @@
 	 */
 	if (e->mem_status == IN_MEMORY)
 	    http->log_type = LOG_TCP_MEM_HIT;
-	else if (check_offline())
+	else if (Config.onoff.offline)
 	    http->log_type = LOG_TCP_OFFLINE_HIT;
 	clientSendMoreData(data, buf, size);
     }
@@ -1782,7 +1778,7 @@
 	 * This hack may hit performance a little, but it's better than 
 	 * blocking!.
 	 */
-#if defined (_SQUID_CYGWIN_) || defined (_SQUID_MSWIN_)
+#ifdef _SQUID_CYGWIN_
 	commSetSelect(conn->fd, COMM_SELECT_READ, clientReadRequest, conn, 0);
 #else
 	clientReadRequest(conn->fd, conn);	/* Read next request */
@@ -1915,7 +1911,7 @@
 	debug(33, 3) ("clientProcessRequest2: storeGet() MISS\n");
 	return LOG_TCP_MISS;
     }
-    if (check_offline()) {
+    if (Config.onoff.offline) {
 	debug(33, 3) ("clientProcessRequest2: offline HIT\n");
 	http->entry = e;
 	return LOG_TCP_HIT;
@@ -2365,19 +2361,11 @@
     clientHttpRequest **H = NULL;
     char *prefix = NULL;
     ErrorState *err = NULL;
-#ifdef _SQUID_MSWIN_
-    sde *F = &sd_table[fd];
-#else
     fde *F = &fd_table[fd];
-#endif
     int len = conn->in.size - conn->in.offset - 1;
     debug(33, 4) ("clientReadRequest: FD %d: reading request...\n", fd);
     Counter.syscalls.sock.reads++;
-#ifdef _SQUID_MSWIN_
-    size = recv(fd, conn->in.buf + conn->in.offset, len);
-#else
     size = read(fd, conn->in.buf + conn->in.offset, len);
-#endif
     if (size > 0) {
 	fd_bytes(fd, size, FD_READ);
 	kb_incr(&Counter.client_http.kbytes_in, size);
@@ -2407,11 +2395,7 @@
 	conn->defer.n++;
 	fd_note(fd, "half-closed");
 	return;
-#ifdef _SQUID_MSWIN_
-    } else if (size ==SOCKET_ERROR) {
-#else
     } else if (size < 0) {
-#endif
 	if (!ignoreErrno(errno)) {
 	    debug(50, 2) ("clientReadRequest: FD %d: %s\n", fd, xstrerror());
 	    comm_close(fd);
@@ -2689,11 +2673,7 @@
     while (max-- && !httpAcceptDefer(sock, NULL)) {
 	memset(&peer, '\0', sizeof(struct sockaddr_in));
 	memset(&me, '\0', sizeof(struct sockaddr_in));
-#ifdef _SQUID_MSWIN_
-	if ((fd = comm_accept(sock, &peer, &me)) ==INVALID_SOCKET ) {
-#else
 	if ((fd = comm_accept(sock, &peer, &me)) < 0) {
-#endif
 	    if (!ignoreErrno(errno))
 		debug(50, 1) ("httpAccept: FD %d: accept failure: %s\n",
 		    sock, xstrerror());
